package com.ruoyi.web.base.controller;


import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.ruoyi.common.core.domain.AjaxResult;
import com.ruoyi.framework.web.service.TokenService;
import com.ruoyi.web.base.domain.BaseEmployee;
import com.ruoyi.web.base.service.IBaseEmployeeService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import java.util.Map;

import static com.ruoyi.common.core.domain.AjaxResult.success;
import static com.ruoyi.common.utils.SecurityUtils.getUsername;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author author
 * @since 2026-02-02
 */
@RestController
@RequestMapping("/base-employee")
@Api("员工管理")
public class BaseEmployeeController {
    @Autowired
    private IBaseEmployeeService employeeService;
    @Autowired
    private TokenService tokenService;

    @ApiOperation("员工管理添加")
    @PostMapping("/add")
    public AjaxResult add(@RequestBody BaseEmployee baseEmployee, HttpServletRequest request) throws Exception {

        String loginOrgId = tokenService.getLoginOrgId(request);
        if (employeeService.count(new QueryWrapper<BaseEmployee>().eq("org_id",loginOrgId).eq("employee_num", baseEmployee.getEmployeeNum())) >0 ){
            throw new Exception("该编号已存在");
        }
        baseEmployee.setOrgId(loginOrgId);
        baseEmployee.setCreateBy(getUsername());

        return success(employeeService.save(baseEmployee));
    }

    @ApiOperation("员工管理修改")
    @PostMapping("/edit")
    public AjaxResult edit(@RequestBody BaseEmployee baseEmployee,HttpServletRequest request) throws Exception {
        String loginOrgId = tokenService.getLoginOrgId(request);
        if (employeeService.count(new QueryWrapper<BaseEmployee>().eq("org_id",loginOrgId).eq("employee_num", baseEmployee.getEmployeeNum()).ne("id",baseEmployee.getId())) >0 ){
            throw new Exception("该编号已存在");
        }

        baseEmployee.setUpdateBy(getUsername());
        return success(employeeService.updateById(baseEmployee));
    }

    @ApiOperation("员工管理删除")
    @PostMapping("/delete")
    public AjaxResult delete(@RequestBody Map<String, String> paramsMap) {
        String ids = paramsMap.get("ids");
        for (String s : ids.split(",")) {
            employeeService.removeById(s);
        }
        return success();
    }

    @ApiOperation("员工管理列表")
    @PostMapping("/list")
    public AjaxResult listAll( HttpServletRequest request){
        return success(employeeService.list(new QueryWrapper<BaseEmployee>().eq("org_id",tokenService.getLoginOrgId(request))));
    }

    @ApiOperation("员工管理分页")
    @GetMapping("/page")
    public AjaxResult page(@RequestParam("pageNum") Integer pageNum, @RequestParam("pageSize") Integer pageSize,HttpServletRequest request
    ) {
        return success(employeeService.page(new Page<BaseEmployee>(pageNum,pageSize),new QueryWrapper<BaseEmployee>().eq("org_id",tokenService.getLoginOrgId(request))));
    }

    @ApiOperation("员工管理详情")
    @PostMapping("/listById")
    public AjaxResult listById(@RequestBody Map<String, String> paramsMap){
        String id = paramsMap.get("id");
        return success(employeeService.getById(id));
    }


}
